Description

Create a regression test suite in openbsc that does end-to-end testing of libmsc and libvir.
Simulate BSC and HLR with binary packages, verifying that MSC and VLR work correctly.

Related issues:

Related to OsmoNITB - Feature #1592: VLR in libmsc, to connect to HLR asynchr... Closed 02/23/2016
Related to OsmoMSC - Feature #1976: VLR / 3G: periodic LU expiry by T3212 Resolved 03/09/2017
History

#1 - 01/18/2017 02:18 PM - neels
- Status changed from New to In Progress

- % Done changed from 0 to 40

In the course of #1592, a quite comprehensive test suite is being developed.
This will be part of the code that is merged to master when #1592 is done.

So far test verifies expected behavior for successful cases,
pending are more tests for rejection at various stages,
as well as timeout behavior.

#2 - 01/18/2017 02:19 PM - neels
- Related to Feature #1592: VLR in libmsc, to connect to HLR asynchronously added

#3 - 02/02/2017 03:45 PM - neels
- % Done changed from 40 to 50

Development of this MSC+VLR end-to-end test is ongoing on the neels/vir branch of openbsc.git.
Recently added/adding testing of UMTS milenage authentication.
(Failure/timeout tests are still to-be-done.)

#4 - 02/07/2017 11:01 AM - neels

The tests have been split up, from one monolithic test program (subscr_conn_tests.c)
to now several tests sharing common code (msc_vir/msc_vlr_test_*.c)

UMTS authentication testing is complete on the VLR branch in msc_vir_test_umts_authen.c,
as well as testing of UMTS authentication over pre-R99 (gsm_milenage()) in msc_vlr_test_gsm_authen.c.

#5 - 02/09/2017 03:24 AM - neels

Started failure testing: msc_vlr_test_hlir_reject.c tests scenarios where the HLR rejects
authentication info and LU. Insert Data failure still to be done.

#6 - 02/09/2017 10:26 PM - neels

(still on vir branch)

Added first couple of rejection as well as timeout tests,
at first for HLR rejecting requests / not sending any replies,
and started MS timeout tests (when MS sends no replies).

#7 - 02/20/2017 01:44 PM - neels

tests development is ongoing, various timeout / rejection tests are still to be added.
Resulting from the timeout tests is the VLR timeout handling "discussion" at https://osmocom.org/issues/1592#note-67

#8 - 02/28/2017 02:18 AM - neels
- % Done changed from 50 to 60

added timeout tests where the MS fails to send messages once authenticity is established (in msc_vir_test_ms_timeout.c). This went along with
implementation of the conn_fsm COMMUNICATING state.

#9 - 03/20/2017 12:52 PM - neels
- Related to Feature #1976: VLR / 3G: periodic LU expiry by T3212 added

#10 - 03/27/2017 01:47 PM - neels
- Status changed from In Progress to Resolved

- % Done changed from 60 to 100

tests will always be an ongoing development. Let's close this issue and open more specific issues like #1976.

#11 - 04/25/2017 01:57 PM - laforge

- Status changed from Resolved to Closed
